// Copyright (C)  2000 Intel Corporation.  All rights reserved.
//
// $Header: /usr/development/orp/orp/common/gc_v2/include/gc_debug.h,v 1.4 2001/10/12 14:47:04 rlhudson Exp $
//


// Debug routine headers and constants.
//



#ifndef _gc_debug_H_
#define _gc_debug_H_

#ifdef _DEBUG
void gc_trace_block (void *the_block, const char *string_x);
#else
inline void gc_trace_block (void *the_block, const char *string_x)
{
    return;
}
#endif

bool is_valid_java_object(Java_java_lang_Object *p_obj_ref);
// Replace the header with this distinct pattern during debugging
// of the heap.
// ww -- I set this to zero to get hash to work properly //#define OBJECT_DEBUG_HEADER 0xCDAB0000
#define OBJECT_DEBUG_HEADER 0

// Add this trailer to an extra word in the object during debugging
#define OBJECT_DEBUG_TRAILER 0xBEBAFECA


//
// Memory patterns.
//
#if 0
//
// Original nursery free bytes.
//
#define DEBUG_NURSERY_ORIGINAL_FREE 0xF0

//
// Replaced nursery free bytes.
//
#define DEBUG_NURSERY_REPLACED_FREE 0xF1

//
// Nurseries that are freed and shouldn't be used.f
//
#define DEBUG_NURSERY_DISCARDED 0xF2

//
// These nursery blocks haven't been used yet:
//
#define DEBUG_STEP_ORIGINAL_FREE 0xF5

//
// These nursery blocks were discarded.
//
#define DEBUG_STEP_DISCARDED 0xF6

//
// This is a debugging pattern placed in all free blocks.
//
#define DEBUG_FREE_FIXED_BLOCK_PATTERN 0xBB

#endif // 0

#endif // _gc_debug_H_
